#pragma once

#include <MidRadio.tlh>

class CMidRadio
{
public:
  CMidRadio(CRITICAL_SECTION& cs, LPUNKNOWN& pUnkControl, HWND mhWnd = NULL);
  ~CMidRadio();
  static HWND GetTopLevelWindow(HWND hWnd);
  static BOOL WaitWithMessageLoop(HANDLE hEvent);

  HRESULT raw_Play();
  HRESULT raw_Stop();
  HRESULT raw_Pause();
  HRESULT raw_Next();
  HRESULT raw_Prev();

  HRESULT get_Src(BSTR * pVal);
  HRESULT put_Src(BSTR pVal);
  HRESULT get_AutoStart(VARIANT_BOOL * pVal);
  HRESULT put_AutoStart(VARIANT_BOOL pVal);
  HRESULT get_Repeat(VARIANT * pVal);
  HRESULT put_Repeat(VARIANT & pVal);
  HRESULT get_Text(BSTR * pVal);
  HRESULT put_Text(BSTR pVal);
  HRESULT get_Volume(long * pVal);
  HRESULT put_Volume(long pVal);
  HRESULT get_Tempo(long * pVal);
  HRESULT put_Tempo(long pVal);
  HRESULT get_TimeFormat(long * pVal);
  HRESULT put_TimeFormat(long pVal);
  HRESULT get_CurrentPosition(BSTR * pVal);
  HRESULT put_CurrentPosition(BSTR pVal);
  HRESULT get_StopPosition(BSTR * pVal);
  HRESULT put_StopPosition(BSTR pVal);
  HRESULT get_Duration(BSTR * pVal);
  HRESULT put_Duration(BSTR pVal);
  HRESULT get_Transpose(long * pVal);
  HRESULT put_Transpose(long pVal);
  HRESULT get_Version(BSTR * pVal);

private:
  CRITICAL_SECTION& m_cs;
  LPUNKNOWN& mUnkControl;
  IMidRadioCtrl* mr;
  HWND hwndTop;
  HCURSOR hcurPrev;
};
